Index: code/branches/ipv6/src/libraries/network/ClientConnection.cc
===================================================================
--- code/branches/ipv6/src/libraries/network/ClientConnection.cc	(revision 7329)
+++ code/branches/ipv6/src/libraries/network/ClientConnection.cc	(revision 7402)
@@ -48,5 +48,5 @@
     this->serverAddress_ = new ENetAddress();
     //set standard address and port
-    enet_address_set_host(this->serverAddress_, "127.0.0.1");
+    enet_address_set_host(this->serverAddress_, "127.0.0.1"); // TODO: check for IPv6 and connect to ::1 instead
     serverAddress_->port = NETWORK_PORT;
   }
@@ -59,5 +59,6 @@
 
   void ClientConnection::setServerAddress( const std::string& serverAddress ) {
-    enet_address_set_host (this->serverAddress_, serverAddress.c_str());
+    if (enet_address_set_host (this->serverAddress_, serverAddress.c_str()) < 0)
+        COUT(1) << "Error: Could not resolve \"" << serverAddress << "\"." << std::endl;
   }
 
@@ -73,12 +74,20 @@
     if ( this->host_ == NULL )
     {
-      COUT(2) << "ClientConnection: host_ == NULL" << std::endl;
+      COUT(1) << "ClientConnection: host_ == NULL" << std::endl;
       // error handling
       return false;
     }
+    assert( this->host_->socket4 != ENET_SOCKET_NULL || this->host_->socket6 != ENET_SOCKET_NULL );
+    if (this->host_->socket4 == ENET_SOCKET_NULL)
+        COUT(2) << "Warning: IPv4 Socket failed." << std::endl;
+    else if (this->host_->socket6 == ENET_SOCKET_NULL)
+        COUT(2) << "Warning: IPv6 Socket failed." << std::endl;
+    else
+        COUT(3) << "Info: Using IPv4 and IPv6 Sockets." << std::endl;
+
     this->server_ = enet_host_connect(this->host_, serverAddress_, NETWORK_CLIENT_CHANNELS, 0);
     if ( this->server_==NULL )
     {
-      COUT(2) << "ClientConnection: server == NULL" << std::endl;
+      COUT(1) << "ClientConnection: server_ == NULL" << std::endl;
       // error handling
       return false;
Index: code/branches/ipv6/src/libraries/network/LANDiscoverable.cc
===================================================================
--- code/branches/ipv6/src/libraries/network/LANDiscoverable.cc	(revision 7329)
+++ code/branches/ipv6/src/libraries/network/LANDiscoverable.cc	(revision 7402)
@@ -70,4 +70,6 @@
       assert( this->host_ == 0 );
       this->host_ = enet_host_create( &bindAddress, 10, 0, 0, 0 );
+      if ( this->host_ == NULL )
+          COUT(1) << "LANDiscoverable: host_ == NULL" << std::endl;
     }
     else
Index: code/branches/ipv6/src/libraries/network/LANDiscovery.cc
===================================================================
--- code/branches/ipv6/src/libraries/network/LANDiscovery.cc	(revision 7329)
+++ code/branches/ipv6/src/libraries/network/LANDiscovery.cc	(revision 7402)
@@ -43,4 +43,6 @@
   {
     this->host_ = enet_host_create(NULL, 10, 0, 0, 0 );
+    if ( this->host_ == NULL )
+        COUT(1) << "LANDiscovery: host_ == NULL" << std::endl;
   }
 
@@ -62,8 +64,12 @@
     address.host = ENET_HOST_BROADCAST;
     peer = enet_host_connect(this->host_, &address, 0, 0);
+    if (peer == NULL)
+        COUT(1) << "Error: Could not send LAN discovery to IPv4 Broadcast." << std::endl;
 
     /* IPv6 */
     enet_address_set_host(&address, "ff02::1"); // TODO: use a multicast group
     peer = enet_host_connect(this->host_, &address, 0, 0);
+    if (peer == NULL)
+        COUT(1) << "Error: Could not send LAN discovery to IPv6 Multicast." << std::endl;
 
     ENetEvent event;
Index: code/branches/ipv6/src/libraries/network/ServerConnection.cc
===================================================================
--- code/branches/ipv6/src/libraries/network/ServerConnection.cc	(revision 7329)
+++ code/branches/ipv6/src/libraries/network/ServerConnection.cc	(revision 7402)
@@ -56,5 +56,6 @@
 
   void ServerConnection::setBindAddress( const std::string& bindAddress ) {
-    enet_address_set_host (this->bindAddress_, bindAddress.c_str());
+    if (enet_address_set_host (this->bindAddress_, bindAddress.c_str()) < 0)
+        COUT(1) << "Error: Could not resolve \"" << bindAddress << "\"." << std::endl;
   }
 
@@ -66,7 +67,17 @@
     this->host_ = enet_host_create(this->bindAddress_, NETWORK_MAX_CONNECTIONS, 0, 0, 0);
     if ( this->host_ == NULL )
-      return false;
+    {
+        COUT(1) << "ServerConnection: host_ == NULL" << std::endl;
+        return false;
+    }
+    assert( this->host_->socket4 != ENET_SOCKET_NULL || this->host_->socket6 != ENET_SOCKET_NULL );
+    if (this->host_->socket4 == ENET_SOCKET_NULL)
+        COUT(2) << "Warning: IPv4 Socket failed." << std::endl;
+    else if (this->host_->socket6 == ENET_SOCKET_NULL)
+        COUT(2) << "Warning: IPv6 Socket failed." << std::endl;
     else
-      return true;
+        COUT(3) << "Info: Using IPv4 and IPv6 Sockets." << std::endl;
+
+    return true;
   }
 