Index: /trunk/src/lib/shell/shell_command.cc
===================================================================
--- /trunk/src/lib/shell/shell_command.cc	(revision 7413)
+++ /trunk/src/lib/shell/shell_command.cc	(revision 7414)
@@ -136,13 +136,28 @@
   /**
    * @brief takes out an InputLine, searching for a Command.
+   * @see const ShellCommand* const ShellCommand::getCommandFromInput(const SubString& strings)
    * @param inputLine: the Input to analyse.
+   * @param paramBegin: The begin of the Splitted SubStrings entry of the Parameters section.
    * @returns: The ShellCommand if found.
    */
-  const ShellCommand* const ShellCommand::getCommandFromInput(const std::string& inputLine)
-  {
-    SubString strings(inputLine, SubString::WhiteSpaces);
+  const ShellCommand* const ShellCommand::getCommandFromInput(const std::string& inputLine, unsigned int& paramBegin)
+  {
+    ShellCommand::getCommandFromInput(SubString(inputLine, SubString::WhiteSpaces), paramBegin);
+  }
+
+  /**
+   * @brief takes out an InputLine, searching for a Command.
+   * @param strings: the Input to analyse.
+   * @param paramBegin: The begin of the Splitted SubStrings entry of the Parameters section.
+   * @returns: The ShellCommand if found.
+   */
+  const ShellCommand* const ShellCommand::getCommandFromInput(const SubString& strings, unsigned int& paramBegin)
+  {
     // no input, no Command.
     if (strings.size() == 0)
-      return NULL;
+    {
+      paramBegin = 0;
+      return NULL;
+    }
 
     // CHECK FOR ALIAS
@@ -162,10 +177,18 @@
       const ShellCommand* retCmd;
       if (strings.size() >= 1)
+      {
         retCmd = ShellCommand::getCommand(strings[1], cmdClass);
+        paramBegin = 2;
+      }
       if (retCmd == NULL && strings.size() >= 2)
+      {
         retCmd = ShellCommand::getCommand(strings[2], cmdClass);
-      return retCmd;
-
-    }
+        paramBegin = 3;
+      }
+      if (retCmd != NULL) // check for the paramBegin.
+        return retCmd;
+    }
+    paramBegin = 0;
+    return NULL;
   }
 
Index: /trunk/src/lib/shell/shell_command.h
===================================================================
--- /trunk/src/lib/shell/shell_command.h	(revision 7413)
+++ /trunk/src/lib/shell/shell_command.h	(revision 7414)
@@ -76,5 +76,6 @@
     static const ShellCommand* const getCommand(const std::string& commandName, const ShellCommandClass* cmdClass);
     static bool exists(const std::string& commandName, const std::string& className);
-    static const ShellCommand* const getCommandFromInput(const std::string& inputLine);
+    static const ShellCommand* const getCommandFromInput(const std::string& inputLine, unsigned int& paramBegin);
+    static const ShellCommand* const getCommandFromInput(const SubString& strings, unsigned int& paramBegin);
 
     const ShellCommandClass* const getCommandClass() const { return this->shellClass; };
Index: /trunk/src/lib/shell/shell_completion.cc
===================================================================
--- /trunk/src/lib/shell/shell_completion.cc	(revision 7413)
+++ /trunk/src/lib/shell/shell_completion.cc	(revision 7414)
@@ -102,5 +102,6 @@
     if (completeType == NullCompletion)
     {
-      if ((command = ShellCommand::getCommandFromInput(input)) != NULL)
+
+      if ((command = ShellCommand::getCommandFromInput(inputSplits, parameterBegin)) != NULL)
         completeType |= ParamCompletion;
     }
@@ -116,6 +117,4 @@
     if (completeType & ParamCompletion)
       this->paramComplete(completeString, command);
-
-
 
     this->generalComplete(input, completeString);
Index: /trunk/src/story_entities/game_world.cc
===================================================================
--- /trunk/src/story_entities/game_world.cc	(revision 7413)
+++ /trunk/src/story_entities/game_world.cc	(revision 7414)
@@ -299,5 +299,5 @@
   else
   {
-    PRINTF(1)("Unable to set Playmode %d:%s\n", playmode, Playable::playmodeToString(playmode).c_str());
+    PRINTF(1)("Unable to set Playmode %d:'%s'\n", playmode, Playable::playmodeToString(playmode).c_str());
   }
 }