Index: code/trunk/src/libraries/util/StringUtils.h
===================================================================
--- code/trunk/src/libraries/util/StringUtils.h	(revision 7413)
+++ code/trunk/src/libraries/util/StringUtils.h	(revision 7417)
@@ -48,11 +48,4 @@
     extern _UtilExport std::string BLANKSTRING;
 
-    //!< Struct that can be used as a comparison object for strings in stl containers.
-    _UtilExport struct StringCompare
-    {
-        bool operator() (const std::string& lhs, const std::string& rhs) const
-            { return lhs.compare(rhs) < 0; }
-    };
-
     _UtilExport std::string getUniqueNumberString();
 
Index: code/trunk/src/modules/notifications/NotificationManager.cc
===================================================================
--- code/trunk/src/modules/notifications/NotificationManager.cc	(revision 7413)
+++ code/trunk/src/modules/notifications/NotificationManager.cc	(revision 7417)
@@ -129,5 +129,5 @@
         for(std::map<NotificationListener*, unsigned int>::iterator it = this->listenerList_.begin(); it != this->listenerList_.end(); it++) // Iterate through all NotificationListeners.
         {
-            std::set<std::string, StringCompare> set = it->first->getTargetsSet();
+            const std::set<std::string>& set = it->first->getTargetsSet();
             bool bAll = set.find(NotificationManager::ALL) != set.end();
             // If either the Notification has as sender 'all', the NotificationListener displays all Notifications or the NotificationListener has the sender of the Notification as target.
@@ -210,5 +210,5 @@
         this->listenerList_[listener] = index; // Add the NotificationListener to the list of NotificationListeners.
 
-        std::set<std::string, StringCompare> set = listener->getTargetsSet();
+        const std::set<std::string>& set = listener->getTargetsSet();
 
         // If all senders are the target of the NotificationListener, then the list of Notifications for that specific NotificationListener is the same as the list of all Notifications.
Index: code/trunk/src/modules/notifications/NotificationQueue.cc
===================================================================
--- code/trunk/src/modules/notifications/NotificationQueue.cc	(revision 7413)
+++ code/trunk/src/modules/notifications/NotificationQueue.cc	(revision 7417)
@@ -356,5 +356,5 @@
         bool first = true;
         // Iterate through the set of targets.
-        for(std::set<std::string, StringCompare>::const_iterator it = this->targets_.begin(); it != this->targets_.end(); it++)
+        for(std::set<std::string>::const_iterator it = this->targets_.begin(); it != this->targets_.end(); it++)
         {
             if(!first)
Index: code/trunk/src/modules/notifications/NotificationQueue.h
===================================================================
--- code/trunk/src/modules/notifications/NotificationQueue.h	(revision 7413)
+++ code/trunk/src/modules/notifications/NotificationQueue.h	(revision 7417)
@@ -124,5 +124,5 @@
             @return Returns a set of strings holding the different targets.
             */
-            inline const std::set<std::string, StringCompare> & getTargetsSet()
+            inline const std::set<std::string> & getTargetsSet()
                 { return this->targets_; }
 
@@ -144,5 +144,5 @@
             bool registered_; //!< Helper variable to remember whether the NotificationQueue is registered already.
 
-            std::set<std::string, StringCompare> targets_; //!< The targets the NotificationQueue displays Notifications of.
+            std::set<std::string> targets_; //!< The targets the NotificationQueue displays Notifications of.
 
             std::multiset<NotificationContainer*, NotificationContainerCompare> ordering_; //!< The NotificationContainers ordered by the time they were registered.
Index: code/trunk/src/orxonox/interfaces/NotificationListener.h
===================================================================
--- code/trunk/src/orxonox/interfaces/NotificationListener.h	(revision 7413)
+++ code/trunk/src/orxonox/interfaces/NotificationListener.h	(revision 7417)
@@ -61,5 +61,5 @@
             virtual ~NotificationListener() {}
 
-            virtual const std::set<std::string, StringCompare> & getTargetsSet() = 0;
+            virtual const std::set<std::string> & getTargetsSet() = 0;
             virtual void update(void) = 0;
             virtual void update(Notification* notification, const std::time_t & time) = 0;